datablock AudioProfile(goldEagleShot1Sound)
{
   filename    = "./goldeagle.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(goldEagleShine)
{
  dragCoefficient = 4;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 250;
  lifetimeVarianceMS = 0;
  textureName = "base/lighting/flare";
  spinSpeed = 360;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "1 1 1 0";
  colors[1] = "1 1 1 1";
  colors[2] = "1 1 0.5 1";
  sizes[0] = 0;
  sizes[1] = 0.3;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.5;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(goldEagleShinemitter)
{
  uiName = "";
  ejectionPeriodMS = 125;
  periodVarianceMS = 20;
  ejectionVelocity = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "goldEagleShine";
};

//muzzle flash effects

datablock ParticleData(goldEagleSparkPa)
{
   dragCoefficient = 7.5;
   gravityCoefficient = 0.5;
   inheritedVelFactor = 0;
   constantAcceleration = 0;
   lifetimeMS         = 400;
   lifetimeVarianceMS = 25;
   textureName = "./spark";
   spinSpeed     = 0;
   spinRandomMin = 0;
   spinRandomMax = 0;

   colors[0] = "1 1 1 1";
   colors[1] = "1 1 0 1";

   sizes[0] = 0.6;
   sizes[1] = 0.15;

   useInvAlpha = false;
};
datablock ParticleEmitterData(goldEagleSparkEm)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 5;
   ejectionOffset   = 0;
   thetaMin = -45;
   thetaMax = 45;
   phiReferenceVel = 0;
   phiVariance     = 180;
   overrideAdvance = false;
   lifetimeMS = 3500;
   particles = "goldEagleSparkPa";

   orientParticles = true;
   useEmitterColors = true;
   uiName = "Golden Eagle Impact Sparks";
};


datablock ParticleData(goldEagleExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/lighting/flare";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 0 1";
	sizes[0]      = 2;
	sizes[1]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(goldEagleExplosionRingEmitter)
{
	lifeTimeMS = 2;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "goldEagleExplosionRingParticle";

   orientParticles  = true;
   orientOnVelocity = false;

   useEmitterColors = true;
   uiName = "Golden Eagle Impact Flash";
};

datablock ExplosionData(goldEagleImpact)
{
   //explosionShape = "";
	soundProfile = desertEagleImpactSound;

   offset = 0.1;

   lifeTimeMS = 150;

   particleEmitter = goldEagleSparkEm;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = goldEagleExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   damageRadius = 2;
   radiusDamage = 10;

   shakeCamera = true;
   camShakeFreq = "12.0 13.0 12.0";
   camShakeAmp = "2.0 2.0 2.0";
   camShakeDuration = 0.75;
   camShakeRadius = 2.5;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "1 1 0";
};

datablock ParticleData(goldEagleTrail)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0;
   textureName          = "base/lighting/corona";
   spinSpeed		= 180;
   spinRandomMin	= 0.0;
   spinRandomMax	= 0.0;

   colors[0]     	= "1 1 1 0.5";
   colors[1]     	= "1 1 0 0.5";
   colors[2]		= "1 1 0 0";

   sizes[0]      	= 2.50;
   sizes[1]      	= 0.25;
   sizes[2]      	= 0.00;

   times[1]		= 0.02;
   times[2]		= 1.00;

   useInvAlpha = false;
};

datablock ParticleEmitterData(goldEagleTrailmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "goldEagleTrail";
};


AddDamageType("goldEagle",   '<bitmap:add-ons/Weapon_Desert_eagle/CI_goldeagle> %1',    '%2 <bitmap:add-ons/Weapon_Desert_eagle/CI_goldeagle> %1',0.2,1);
datablock ProjectileData(goldEagleProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::goldEagle;
   radiusDamageType    = $DamageType::goldEagle;

   brickExplosionRadius = 0.2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1500;
   verticalImpulse	  = 1000;
   explosion           = goldEagleImpact;
   particleEmitter     = "goldEagleTrailmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0.1;

   armingDelay         = 250;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 1;
   bounceFriction      = -5;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Golden Eagle Bullet";
};

//////////
// item //
//////////
datablock ItemData(goldEagleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./deagleitem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	lightType = "PulsingLight";
	lightColor = "1 0.847 0";
	lightRadius = 5;
	lightTime = 750;

	//gui stuff
	uiName = "Golden Eagle";
	iconName = "./icon_deagle";
	doColorShift = true;
	colorShiftColor = "1 0.847 0 1";

	 // Dynamic properties defined by the scripts
	image = goldEagleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(goldEagleImage)
{
   // Basic Item properties
   shapeFile = "./deagle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = goldEagleItem;
   ammo = " ";
   projectile = goldEagleProjectile;
   projectileType = Projectile;

	casing = desertEagleShellDebris;
	shellExitDir        = "0.75 0.0 1.5";	//"1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 1.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = goldEagleItem.colorShiftColor;

   cloakable = true;

   lightType = "PulsingLight";
   lightColor = "1 0.847 0";
   lightRadius = 5;
   lightTime = 750;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]			 = desertEagleEquipSound;
	stateSequence[0]		 = "draw";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]			= goldEagleShinemitter;
	stateEmitterTime[1]		= 1000.0;
	stateEmitterNode[1]		= "ejectPoint";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.7;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]					= goldEagleShot1Sound;
	stateEjectShell[2]       	= true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Ready";

};

function goldEagleImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	%obj.playThread(2, jump);
	Parent::onFire(%this,%obj,%slot);	
}
