datablock AudioProfile(desertEagleShot1Sound)
{
   filename    = "./deagle.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(desertEagleEquipSound)
{
   filename    = "./draw.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(desertEagleImpactSound)
{
   filename    = "./ric.wav";
   description = AudioClose3d;
   preload = true;
};


//shell
datablock DebrisData(desertEagleShellDebris)
{
	shapeFile = "./Casing.dts";
	lifetime = 2.0;
	minSpinSpeed = 799.9;
	maxSpinSpeed = 800.0;
	elasticity = 0.15;
	friction = 0.45;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 3;
};

//muzzle flash effects

datablock ParticleData(desertEagleSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(desertEagleSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "desertEagleSmokeParticle";

   uiName = "Desert Eagle Gunsmoke";
};


datablock ParticleData(desertEagleSparkPa)
{
   dragCoefficient = 7.5;
   gravityCoefficient = 0.5;
   inheritedVelFactor = 0;
   constantAcceleration = 0;
   lifetimeMS         = 400;
   lifetimeVarianceMS = 25;
   textureName = "./spark";
   spinSpeed     = 0;
   spinRandomMin = 0;
   spinRandomMax = 0;

   colors[0] = "1 1 0 1";
   colors[1] = "1 0 0 1";

   sizes[0] = 0.6;
   sizes[1] = 0.15;

   useInvAlpha = false;
};
datablock ParticleEmitterData(desertEagleSparkEm)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 5;
   ejectionOffset   = 0;
   thetaMin = -45;
   thetaMax = 45;
   phiReferenceVel = 0;
   phiVariance     = 180;
   overrideAdvance = false;
   lifetimeMS = 3500;
   particles = "desertEagleSparkPa";

   orientParticles = true;
   useEmitterColors = true;
   uiName = "Desert Eagle Impact Sparks";
};


datablock ParticleData(desertEagleExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/lighting/flare";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0 1";
	colors[1]     = "1 0 0 1";
	sizes[0]      = 2;
	sizes[1]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(desertEagleExplosionRingEmitter)
{
	lifeTimeMS = 2;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "desertEagleExplosionRingParticle";

   orientParticles  = true;
   orientOnVelocity = false;

   useEmitterColors = true;
   uiName = "Desert Eagle Impact Flash";
};

datablock ExplosionData(desertEagleImpact)
{
   //explosionShape = "";
	soundProfile = desertEagleImpactSound;

   offset = 0.1;

   lifeTimeMS = 150;

   particleEmitter = desertEagleSparkEm;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = desertEagleExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 2.5;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 0;
   lightStartColor = "1 1 0";
   lightEndColor = "1 0 0";
};

datablock ParticleData(desertEagleTracer)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 40;
   lifetimeVarianceMS   = 0;
   textureName          = "base/lighting/lightFalloffMono";
   spinSpeed		= 0.0;
   spinRandomMin	= 0.0;
   spinRandomMax	= 0.0;

   colors[0]     	= "1 1 0 0.5";
   colors[1]     	= "1 0 0 0.5";

   sizes[0]      	= 0.20;
   sizes[1]      	= 0.10;
   sizes[2]      	= 0.05;

   useInvAlpha = false;
};

datablock ParticleEmitterData(desertEagleTracemitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "desertEagleTracer";
};


AddDamageType("desertEagle",   '<bitmap:add-ons/Weapon_Desert_eagle/CI_deagle> %1',    '%2 <bitmap:add-ons/Weapon_Desert_eagle/CI_deagle> %1',0.2,1);
datablock ProjectileData(desertEagleProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 75;
   directDamageType    = $DamageType::desertEagle;
   radiusDamageType    = $DamageType::desertEagle;

   brickExplosionRadius = 0.1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 25;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1200;
   verticalImpulse	  = 800;
   explosion           = desertEagleImpact;
   particleEmitter     = "desertEagleTracemitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0.1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Deagle Bullet";
};

//////////
// item //
//////////
datablock ItemData(desertEagleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./deagleitem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Desert Eagle";
	iconName = "./icon_deagle";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = desertEagleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(desertEagleImage)
{
   // Basic Item properties
   shapeFile = "./deagle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = desertEagleItem;
   ammo = " ";
   projectile = desertEagleProjectile;
   projectileType = Projectile;

	casing = desertEagleShellDebris;
	shellExitDir        = "0.75 0.0 1.5";	//"1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 1.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = desertEagleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   cloakable = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= desertEagleEquipSound;
	stateSequence[0]	= "draw";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.7;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]					= desertEagleFlashEmitter;
	stateEmitterTime[2]				= 0.01;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= desertEagleShot1Sound;
	stateEjectShell[2]       	= true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= desertEagleSmokeEmitter;
	stateEmitterTime[3]				= 0.01;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	stateSequence[4]		= "Ready";

};

function desertEagleImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
	%obj.playThread(2, jump);
	Parent::onFire(%this,%obj,%slot);	
}

exec("./goldeagle.cs");